
  UChar = Byte;
  PVoid = Pointer;

  PQGlobal = ^QGlobal;
  QGlobal = record
    ThreadCnt: ULong;
    ProcCnt:   ULong;
    ModuleCnt: ULong;
  end;

  PQThread = ^QThread;
  QThread = record
    RecType:  ULong;
    ThreadID: UShort;
    SlotID:   UShort;
    SleepID:  ULong;
    Priority: ULong;
    SysTime:  ULong;
    UserTime: ULong;
    State:    UChar;
    Pad1:     UChar;
    Pad2:     UShort;
  end;

  PQFds = ^QFds;
  QFds = record
    N1:       UShort;
    N2:       UShort;
    N3:       UShort;
    N4:       UShort;
    N5:       UShort;
    N6:       UShort;
    FileSize: ULong;
    N7:       UShort;
    N8:       UShort;
    Reserved: UShort;
  end;

  PQFile = ^QFile;
  QFile = record
    RecType:  ULong;
    Next:     PQFile;
    OpenCnt:  ULong;
    FileData: PQFds;
    Name: array[0..0] of Char;
  end;

  PQProcess = ^QProcess;
  QProcess = record
    RecType:   ULong;
    Threads:   PQThread;
    PID:       UShort;
    PPID:      UShort;
    PType:     ULong;
    State:     ULong;
    SessID:    ULong;
    HNDMod:    UShort;
    ThreadCnt: UShort;
    Reserved1: ULong;
    Reserved2: PVoid;
    Sem16Cnt:  UShort;
    DllCnt:    UShort;
    ShrMemCnt: UShort;
    FdsCnt:    UShort;
    Sem16s:    PUShort;
    Dlls:      PUShort;
    ShrMems:   PUShort;
    Fds:       PUShort;
  end;

  PQSema = ^QSema;
  QSema = record
    Next:       PQSema;
    RefCnt:     UShort; {Owner ?}
    SysFlags:   UChar;
    SysProcCnt: UChar;  {References}
    Reserved1:  UChar;
    Reserved2:  UShort;
    Index:      UShort;
    Name:       array[0..0] of Char;
  end;

  PQSemStruc = ^QSemStruc;
  QSemStruc = record
    RecType:   ULong;
    Reserved1: ULong;
    Reserved2: ULong;
    Index:     ULong;
    Sema:      QSema;
  end;

  PQShrMem = ^QShrMem;
  QShrMem = record
    Next:   PQShrMem;
    HNDShr: UShort;
    SelShr: UShort;
    RefCnt: UShort;
    Name:   array[0..0] of Char;
  end;

  PQModule = ^QModule;
  QModule = record
    Next:      PQModule;
    HNDMod:    UShort;
    MType:     UShort;
    RefCnt:    ULong;
    SegCnt:    ULong;
    Reserved:  PVoid;
    Name:      PChar;
    ModRef:    array[0..0] of UShort;
  end;

  PQTopLevel = ^QTopLevel;
  QTopLevel = record
    GblData:    PQGlobal;
    ProcData:   PQProcess;
    SemaData:   PQSemStruc;
    Reserved1:  PVoid;
    ShrMemData: PQShrMem;
    ModData:    PQModule;
    Reserved2:  PVoid;
    FileData:   PQFile;
    Data:       record end;
  end;

